diff --git a/content/common/media/media_channel_host.h b/content/common/media/media_channel_host.h
new file mode 100644
index 0000000..752a3d6
--- /dev/null
+++ b/content/common/media/media_channel_host.h
@@ -0,0 +1,129 @@
+// Copyright (c) 2012 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CONTENT_COMMON_MEDIA_MESSAGE_DISPATCHER_HOST_H_
+#define CONTENT_COMMON_MEDIA_MESSAGE_DISPATCHER_HOST_H_
+
+#include <string>
+#include <vector>
+
+#include "base/atomic_sequence_num.h"
+#include "base/containers/hash_tables.h"
+#include "base/memory/ref_counted.h"
+#include "base/memory/scoped_ptr.h"
+#include "base/memory/weak_ptr.h"
+#include "base/process/process.h"
+#include "base/synchronization/lock.h"
+#include "content/common/content_export.h"
+#include "content/common/message_router.h"
+#include "ipc/ipc_channel_handle.h"
+#include "ipc/ipc_sync_channel.h"
+#include "ipc/message_filter.h"
+#include "ui/events/latency_info.h"
+#include "ui/gfx/geometry/size.h"
+#include "ui/gfx/gpu_memory_buffer.h"
+#include "ui/gfx/native_widget_types.h"
+#include "ui/gl/gpu_preference.h"
+
+class GURL;
+
+namespace base {
+class MessageLoop;
+class WaitableEvent;
+}
+
+namespace IPC {
+class SyncMessageFilter;
+}
+
+namespace media {
+class WebMediaPlayerMessageDispatcher;
+}
+
+namespace content {
+
+// Encapsulates an IPC channel between the client and one media process.
+// On the media process side there's a corresponding channel.
+// Every method can be called on any thread with a message loop, except for the
+// IO thread.
+class MediaChannelHost : public IPC::Sender,
+                         public base::RefCountedThreadSafe<MediaChannelHost> {
+ public:
+  // Must be called on the main thread
+  static scoped_refptr<MediaChannelHost> Create(
+      const IPC::ChannelHandle& channel_handle,
+      base::WaitableEvent* shutdown_event);
+
+  bool IsLost() const {
+    DCHECK(channel_filter_.get());
+    return channel_filter_->IsLost();
+  }
+
+  // IPC::Sender implementation:
+  bool Send(IPC::Message* msg) override;
+
+  void RegisterDispatcher(int, media::WebMediaPlayerMessageDispatcher*);
+  void RemoveDispatcher(int);
+
+  // Destroy this channel.
+  void DestroyChannel();
+
+ private:
+  friend class base::RefCountedThreadSafe<MediaChannelHost>;
+  MediaChannelHost();
+  ~MediaChannelHost() override;
+  void Connect(const IPC::ChannelHandle& channel_handle,
+               base::WaitableEvent* shutdown_event);
+  bool InternalSend(IPC::Message* msg);
+  void InternalFlush();
+
+  // A filter used internally to route incoming messages from the IO thread
+  // to the correct message loop. It also maintains some shared state between
+  // all the contexts.
+  class MessageFilter : public IPC::MessageFilter {
+   public:
+    MessageFilter();
+
+    void RegisterDispatcher(int, media::WebMediaPlayerMessageDispatcher*);
+    void RemoveDispatcher(int);
+
+    // IPC::MessageFilter implementation
+    // (called on the IO thread):
+    bool OnMessageReceived(const IPC::Message& msg) override;
+    void OnChannelError() override;
+
+    // The following methods can be called on any thread.
+
+    // Whether the channel is lost.
+    bool IsLost() const;
+
+   private:
+    ~MessageFilter() override;
+
+    typedef base::hash_map<int, media::WebMediaPlayerMessageDispatcher*>
+        WebMediaPlayerDispatcherMap;
+
+    // Threading notes: |dispatchers_| is only accessed on the IO thread. Every
+    // other field is protected by |lock_|.
+    WebMediaPlayerDispatcherMap dispatchers_;
+
+    // Protects all fields below this one.
+    mutable base::Lock lock_;
+
+    // Whether the channel has been lost.
+    bool lost_;
+  };
+
+  scoped_ptr<IPC::SyncChannel> channel_;
+  scoped_refptr<MessageFilter> channel_filter_;
+
+  // A filter for sending messages from thread other than the main thread.
+  scoped_refptr<IPC::SyncMessageFilter> sync_filter_;
+
+  DISALLOW_COPY_AND_ASSIGN(MediaChannelHost);
+};
+
+}  // namespace content
+
+#endif  // CONTENT_COMMON_MEDIA_MESSAGE_DISPATCHER_HOST_H_
diff --git a/content/common/media/media_config.h b/content/common/media/media_config.h
new file mode 100644
index 0000000..4439103
--- /dev/null
+++ b/content/common/media/media_config.h
@@ -0,0 +1,12 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CONTENT_COMMON_MEDIA_MEDIA_CONFIG_H_
+#define CONTENT_COMMON_MEDIA_MEDIA_CONFIG_H_
+
+// This file declares common preprocessor configuration for the GPU process.
+
+#include "build/build_config.h"
+
+#endif  // CONTENT_COMMON_MEDIA_MEDIA_CONFIG_H_
diff --git a/content/common/media/media_messages.h b/content/common/media/media_messages.h
new file mode 100644
index 0000000..c185442
--- /dev/null
+++ b/content/common/media/media_messages.h
@@ -0,0 +1,83 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+// Multiply-included message file, hence no include guard here, but see below
+// for a much smaller-than-usual include guard section.
+
+#include <string>
+#include <vector>
+
+#include "base/memory/shared_memory.h"
+#include "content/common/content_export.h"
+#include "content/common/content_param_traits.h"
+#include "content/common/media/media_process_launch_causes.h"
+#include "content/public/common/common_param_traits.h"
+#include "ipc/ipc_channel_handle.h"
+#include "ipc/ipc_message_macros.h"
+
+#undef IPC_MESSAGE_EXPORT
+#define IPC_MESSAGE_EXPORT CONTENT_EXPORT
+
+#define IPC_MESSAGE_START MediaMsgStart
+
+IPC_ENUM_TRAITS_MAX_VALUE(content::CauseForMediaLaunch,
+                          content::CAUSE_FOR_MEDIA_LAUNCH_MAX_ENUM - 1)
+
+//------------------------------------------------------------------------------
+// Media Messages
+// These are messages from the browser to the media process.
+
+// Tells the media process to initialize itself. The browser explicitly
+// requests this be done so that we are guaranteed that the channel is set
+// up between the browser and media process before doing any work that might
+// potentially crash the media process. Detection of the child process
+// exiting abruptly is predicated on having the IPC channel set up.
+IPC_MESSAGE_CONTROL0(MediaMsg_Initialize)
+
+// Tells the media process to create a new channel for communication with a
+// given client.  The channel name is returned in a
+// MediaHostMsg_ChannelEstablished message.  The client ID is passed so that
+// the media process reuses an existing channel to that process if it exists.
+// This ID is a unique opaque identifier generated by the browser process.
+IPC_MESSAGE_CONTROL1(MediaMsg_EstablishChannel, int /* client_id */)
+
+// Tells the media process to close the channel identified by IPC channel
+// handle.  If no channel can be identified, do nothing.
+IPC_MESSAGE_CONTROL1(MediaMsg_CloseChannel,
+                     IPC::ChannelHandle /* channel_handle */)
+
+// Tells the media process to clean all resources.
+IPC_MESSAGE_CONTROL0(MediaMsg_Clean)
+
+// Tells the media process to crash.
+IPC_MESSAGE_CONTROL0(MediaMsg_Crash)
+
+// Tells the media process to hang.
+IPC_MESSAGE_CONTROL0(MediaMsg_Hang)
+
+//------------------------------------------------------------------------------
+// Media Host Messages
+// These are messages to the browser.
+
+// A renderer sends this when it wants to create a connection to the media
+// process. The browser will create the media process if necessary, and will
+// return a handle to the channel via a MediaChannelEstablished message.
+IPC_SYNC_MESSAGE_CONTROL1_2(MediaHostMsg_EstablishMediaChannel,
+                            content::CauseForMediaLaunch,
+                            int /* client id */,
+                            IPC::ChannelHandle /* handle to channel */)
+
+// Response from the media process to a MediaHostMsg_Initialize message.
+IPC_MESSAGE_CONTROL1(MediaHostMsg_Initialized, bool /* result */)
+
+// Response from the media process to a MediaHostMsg_EstablishChannel message.
+IPC_MESSAGE_CONTROL1(MediaHostMsg_ChannelEstablished,
+                     IPC::ChannelHandle /* channel_handle */)
+
+// Message from the media process to add a media process log message to the
+// about:media page.
+IPC_MESSAGE_CONTROL3(MediaHostMsg_OnLogMessage,
+                     int /*severity*/,
+                     std::string /* header */,
+                     std::string /* message */)
diff --git a/content/common/media/media_player_messages_enums_gstreamer.h b/content/common/media/media_player_messages_enums_gstreamer.h
new file mode 100644
index 0000000..512e16f
--- /dev/null
+++ b/content/common/media/media_player_messages_enums_gstreamer.h
@@ -0,0 +1,15 @@
+// Copyright 2013 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CONTENT_COMMON_MEDIA_MEDIA_PLAYER_MESSAGES_ENUMS_GSTREAMER_H_
+#define CONTENT_COMMON_MEDIA_MEDIA_PLAYER_MESSAGES_ENUMS_GSTREAMER_H_
+
+// Dictates which type of media playback is being initialized.
+enum MediaPlayerHostMsg_Initialize_Type {
+  MEDIA_PLAYER_TYPE_URL,
+  MEDIA_PLAYER_TYPE_MEDIA_SOURCE,
+  MEDIA_PLAYER_TYPE_LAST = MEDIA_PLAYER_TYPE_MEDIA_SOURCE
+};
+
+#endif  // CONTENT_COMMON_MEDIA_MEDIA_PLAYER_MESSAGES_ENUMS_GSTREAMER_H_
diff --git a/content/common/media/media_player_messages_gstreamer.h b/content/common/media/media_player_messages_gstreamer.h
new file mode 100644
index 0000000..975b883
--- /dev/null
+++ b/content/common/media/media_player_messages_gstreamer.h
@@ -0,0 +1,176 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+// IPC messages for android media player.
+// Multiply-included message file, hence no include guard.
+
+#include "base/basictypes.h"
+#include "base/time/time.h"
+#include "content/common/content_export.h"
+#include "content/common/media/media_player_messages_enums_gstreamer.h"
+#include "ipc/ipc_message_macros.h"
+#include "url/gurl.h"
+
+#undef IPC_MESSAGE_EXPORT
+#define IPC_MESSAGE_EXPORT CONTENT_EXPORT
+#define IPC_MESSAGE_START MediaPlayerMsgStart
+
+// From render process to media process
+IPC_SYNC_MESSAGE_CONTROL1_0(MediaPlayerMsg_Create, int /* player_id */)
+
+// Start the player for playback.
+IPC_MESSAGE_CONTROL3(MediaPlayerMsg_Load, int /* player_id */, GURL /* url */,
+                     unsigned /* position_update_interval */)
+
+IPC_MESSAGE_CONTROL1(MediaPlayerMsg_Start, int /* player_id */)
+
+IPC_MESSAGE_CONTROL1(MediaPlayerMsg_Pause, int /* player_id */)
+
+IPC_MESSAGE_CONTROL2(MediaPlayerMsg_Seek,
+                     int /* player_id */,
+                     base::TimeDelta /* time */)
+
+IPC_SYNC_MESSAGE_CONTROL1_0(MediaPlayerMsg_Release, int /* player_id */)
+
+// The player is done with the current texture
+IPC_MESSAGE_CONTROL2(MediaPlayerMsg_ReleaseTexture,
+                     int /* player_id */,
+                     unsigned /* texture_id */)
+
+// Request the player to add a media source buffer.
+IPC_MESSAGE_CONTROL4(MediaPlayerMsg_AddSourceId,
+                     int /* player_id */,
+                     std::string /* source id */,
+                     std::string /* type */,
+                     std::vector<std::string> /* codecs */)
+
+// Request the player to remove a media source buffer.
+IPC_MESSAGE_CONTROL2(MediaPlayerMsg_RemoveSourceId,
+                     int /* player_id */,
+                     std::string /* source id */)
+
+// Request the player to set the new duration.
+IPC_MESSAGE_CONTROL2(MediaPlayerMsg_SetDuration,
+                     int /* player_id */,
+                     base::TimeDelta /* duration */)
+
+// Request the player to mark EOS the media source.
+IPC_MESSAGE_CONTROL1(MediaPlayerMsg_MarkEndOfStream, int /* player_id */)
+
+// Request the player to unmark EOS the media source.
+IPC_MESSAGE_CONTROL1(MediaPlayerMsg_UnmarkEndOfStream, int /* player_id */)
+
+// Request the player to set the MSE sequence mode.
+IPC_MESSAGE_CONTROL3(MediaPlayerMsg_SetSequenceMode,
+                     int /* player_id */,
+                     std::string /* source id */,
+                     bool /* sequence mode */)
+
+// Request the player to process source buffer data.
+IPC_MESSAGE_CONTROL4(MediaPlayerMsg_AppendData,
+                     int /* player_id */,
+                     std::string /* source id */,
+                     std::vector<unsigned char> /* data */,
+                     std::vector<base::TimeDelta> /* start, end, offset */)
+
+// Request the player to abort the current segment and reset the parser.
+IPC_MESSAGE_CONTROL2(MediaPlayerMsg_Abort,
+                     int /* player_id */,
+                     std::string /* source id */)
+
+// Request the play to configure group timestamps for the sequence.
+IPC_MESSAGE_CONTROL3(MediaPlayerMsg_SetGroupStartTimestampIfInSequenceMode,
+                     int /* player_id */,
+                     std::string /* source id */,
+                     base::TimeDelta /* timestamp offset */)
+
+// Request the play to remove a segment for a source buffer.
+IPC_MESSAGE_CONTROL4(MediaPlayerMsg_RemoveSegment,
+                     int /* player_id */,
+                     std::string /* source id */,
+                     base::TimeDelta /* start */,
+                     base::TimeDelta /* end */)
+
+// Add new DRM key.
+IPC_MESSAGE_CONTROL4(MediaPlayerMsg_AddKey,
+                     int /* player_id */,
+                     std::string /* session id */,
+                     std::string /* key id */,
+                     std::string /* key */)
+
+// From media process to render process
+IPC_MESSAGE_ROUTED1(MediaPlayerMsg_MediaBufferingUpdate, int /* percent */)
+
+// A media playback error has occurred.
+IPC_MESSAGE_ROUTED1(MediaPlayerMsg_MediaError, int /* error */)
+
+// Playback is completed.
+IPC_MESSAGE_ROUTED0(MediaPlayerMsg_MediaPlaybackCompleted)
+
+// Media metadata has changed.
+IPC_MESSAGE_ROUTED1(MediaPlayerMsg_MediaDurationChanged,
+                    base::TimeDelta /* duration */)
+
+// Media seek is completed.
+IPC_MESSAGE_ROUTED1(MediaPlayerMsg_SeekCompleted,
+                    base::TimeDelta /* current_time */)
+
+// Video size has changed.
+IPC_MESSAGE_ROUTED2(MediaPlayerMsg_MediaVideoSizeChanged,
+                    int /* width */,
+                    int /* height */)
+
+// The current play time has updated.
+IPC_MESSAGE_ROUTED2(MediaPlayerMsg_MediaTimeUpdate,
+                    base::TimeDelta /* current_timestamp */,
+                    base::TimeTicks /* current_time_ticks */)
+
+// The player has been released.
+IPC_MESSAGE_ROUTED0(MediaPlayerMsg_MediaPlayerReleased)
+
+// The player exited fullscreen.
+IPC_MESSAGE_ROUTED0(MediaPlayerMsg_DidExitFullscreen)
+
+// The player started playing.
+IPC_MESSAGE_ROUTED0(MediaPlayerMsg_DidMediaPlayerPlay)
+
+// The player was paused.
+IPC_MESSAGE_ROUTED0(MediaPlayerMsg_DidMediaPlayerPause)
+
+// The player is ready to use the current frame
+IPC_MESSAGE_ROUTED5(MediaPlayerMsg_SetCurrentFrame,
+                    int /* width */,
+                    int /* height */,
+                    unsigned /* texture_id */,
+                    unsigned /* target */,
+                    std::vector<int32_t> /* name */)
+
+// The player has setup its source element.
+IPC_MESSAGE_ROUTED0(MediaPlayerMsg_SourceSelected)
+
+// The player has added a media source buffer.
+IPC_MESSAGE_ROUTED1(MediaPlayerMsg_DidAddSourceId, std::string /* source id */)
+
+// The player has removed a media source buffer.
+IPC_MESSAGE_ROUTED1(MediaPlayerMsg_DidRemoveSourceId,
+                    std::string /* source id */)
+
+// The player validated a media source buffer.
+IPC_MESSAGE_ROUTED1(MediaPlayerMsg_InitSegmentReceived,
+                    std::string /* source id */)
+
+// The player updated the time range for last append buffer.
+IPC_MESSAGE_ROUTED2(MediaPlayerMsg_BufferedRangeUpdate,
+                    std::string /* source id */,
+                    std::vector<base::TimeDelta> /* ranges */)
+
+// The player updated the timestamp offset for the next sequence.
+IPC_MESSAGE_ROUTED2(MediaPlayerMsg_TimestampOffsetUpdate,
+                    std::string /* source id */,
+                    base::TimeDelta /* timestamp_offset */)
+
+// The player requested the DRM key.
+IPC_MESSAGE_ROUTED2(MediaPlayerMsg_NeedKey,
+                    std::string /* system_id */,
+                    std::vector<unsigned char> /* init_data */)
diff --git a/content/common/media/media_process_launch_causes.h b/content/common/media/media_process_launch_causes.h
new file mode 100644
index 0000000..c1b3f5a
--- /dev/null
+++ b/content/common/media/media_process_launch_causes.h
@@ -0,0 +1,23 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CONTENT_COMMON_MEDIA_MEDIA_PROCESS_LAUNCH_CAUSES_H_
+#define CONTENT_COMMON_MEDIA_MEDIA_PROCESS_LAUNCH_CAUSES_H_
+
+namespace content {
+
+enum CauseForMediaLaunch {
+  // Start enum from 2 to keep the same values for the histogram.
+  CAUSE_FOR_MEDIA_LAUNCH_NO_LAUNCH = 2,
+  CAUSE_FOR_MEDIA_LAUNCH_BROWSER_STARTUP,
+  CAUSE_FOR_MEDIA_LAUNCH_RENDERER,
+
+  // All new values should be inserted above this point so that
+  // existing values continue to match up with those in histograms.xml.
+  CAUSE_FOR_MEDIA_LAUNCH_MAX_ENUM
+};
+
+}  // namespace content
+
+#endif  // CONTENT_COMMON_MEDIA_MEDIA_PROCESS_LAUNCH_CAUSES_H_
diff --git a/content/common/sandbox_init_mac.cc b/content/common/sandbox_init_mac.cc
index 2597a75..4231805 100644
--- a/content/common/sandbox_init_mac.cc
+++ b/content/common/sandbox_init_mac.cc
@@ -57,6 +57,12 @@ bool GetSandboxTypeFromCommandLine(int* sandbox_type,
     return false;
   } else if (process_type == switches::kPpapiPluginProcess) {
     *sandbox_type = SANDBOX_TYPE_PPAPI;
+#if defined(USE_GSTREAMER)
+  } else if (process_type == switches::kMediaProcess) {
+    if (command_line.HasSwitch(switches::kDisableMediaSandbox))
+      return false;
+    *sandbox_type = SANDBOX_TYPE_MEDIA;
+#endif
   } else {
     // This is a process which we don't know about, i.e. an embedder-defined
     // process. If the embedder wants it sandboxed, they have a chance to return
